#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "fitgsl.h"

#define DATA_MAX 1000
#define X_MAX      243

int
main(
    int argc,
    char *argv[])
{
    char line[LINE_MAX + 1];
    char *p_ch;
    int i;
    int seek;
    int x_data[DATA_MAX];
    int y_data[DATA_MAX];
    int count_data;
    float fwhm;
    float fitgaus_count[FITGSL_NUM_COEFF];
    float x;
    float y;
    float x_max;
    float y_max;
    FILE *fr;
    fitgsl_data *fitgaus_data;

    if (argc != 2) {
        printf("Usage: %s xy.data", argv[0]);
        return 1;
    }

    if ((fr = fopen(argv[1], "r")) == NULL) {
        perror("fopen()");
        return 1;
    }

    count_data = 0;
    while (fgets(line, LINE_MAX, fr) != NULL) {
        ++count_data;
        line[strlen(line) - 1] = '\0';

        if ((p_ch = strchr(line, ' ')) == NULL) {
            printf("Bad xy.data\n");
            return 1;
        }

        *p_ch = '\0';

        x_data[count_data] = atoi(line);
        y_data[count_data] = atoi((char *) &line[strlen(line) + 1]);

#ifdef DBG
        printf("%i %i\n", x_data[count_data], y_data[count_data]);
#endif
    }

    fclose(fr);

    fitgaus_data = fitgsl_alloc_data(count_data - 60);

    seek = 0;
    for (i = 0; i < count_data; ++i) {
        //if ((i > X_MAX-30) && (i < X_MAX+30)) {
        //  ++seek;
        //  continue;
        //}

        fitgaus_data->pt[i - seek].x = (float) x_data[i];
        fitgaus_data->pt[i - seek].y = (float) y_data[i];
    }

    fitgsl_lm(fitgaus_data, fitgaus_count, 0);
    fwhm = 2.35482 * fitgaus_count[FITGSL_W_INDEX];

    printf("# FWHM = %f\n", fwhm);

    x = 0;
    y_max = 0;
    for (i = 0; i < count_data; ++i) {
        y = fitgsl_fx(fitgaus_count[FITGSL_B_INDEX],
                      fitgaus_count[FITGSL_P_INDEX],
                      fitgaus_count[FITGSL_C_INDEX],
                      fitgaus_count[FITGSL_W_INDEX], (float) x);

        if (y > y_max) {
            y_max = y;
            x_max = x;
        }

        printf("%i %i %f %f\n", x_data[i], y_data[i], x++, y);
    }

    printf("# x_max = %f, y_max = %f\n", x_max, y_max);

    fitgsl_free_data(fitgaus_data);

    return 0;
}
