#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <getopt.h>
#include <sys/types.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <glade/glade.h>
#include <glade/glade-build.h>

#include "global.h"
#include "ipc.h"

#define GET_WIDGET(name) glade_xml_get_widget(xml, name)
#define GET_WINDOW(name) (GtkWindow *)glade_xml_get_widget(xml, name)

static const char glade_xml[] = "../share/opso.glade";
//static GList          *p_widgets_list;

static GladeXML *xml;
static GdkColor red_color;
static GdkColor black_color;

/**********************************/

/* Signal handler functions begin */

void
toggled(
    GtkWidget * widget)
{
    char *p_name;

    p_name = (char *) gtk_widget_get_name(widget);

    printf("%s\n", p_name);


    lock(pix_semid, 0);
    p_pix_sm->input_RB = 2;
    unlock(pix_semid, 0);

    // if (widget.get_active()):
    //   value = 1
    // else:
    //   value = 0
    // 
    //   lock(pix_semid, 0);

    // if (name == "I_SLIDING_AVERAGE_RB"):
    //   sm.write_int(pix["I_ZMENA_PRU"], 1)
    // elif (name in ["I_INPUT_RB", "input_file_RB"]):
    //   name = "I_INPUT_RB"
    //   if (objekt["I_INPUT_RB"].get_active()):
    //     if (self.target_slit["x"] != 0):
    //       objekt["I_TARGET_X_SL"].set_value(self.target_slit["x"])
    //       objekt["I_TARGET_Y_SL"].set_value(self.target_slit["y"])
    //     value = 0
    //   elif (objekt["input_file_RB"].get_active()):
    //     value = 2
    //   else:
    //     if (self.target_field["x"] != 0):
    //       objekt["I_TARGET_X_SL"].set_value(self.target_field["x"])
    //       objekt["I_TARGET_Y_SL"].set_value(self.target_field["y"])
    //     value = 1
    // elif (name == "I_ZOOM_BIND_TARGET_CB"):
    //   self.zoom_target_BT_clicked(None)
    // elif (name == "I_ZOOM_CB"):
    //   if (value):
    //     objekt["I_AUTOMATION_POINTING_TB"].set_sensitive(True)
    //     objekt["I_SHOW_VALUE_IN_QUADRANT_CB"].set_sensitive(True)
    //   else:
    //     objekt["I_AUTOMATION_POINTING_TB"].set_active(False)
    //     objekt["I_AUTOMATION_POINTING_TB"].set_sensitive(False)
    //     objekt["I_SHOW_VALUE_IN_QUADRANT_CB"].set_sensitive(False)
    // elif (name == "I_AUTOMATION_POINTING_TB"):
    //   if (value):
    //     objekt["calibration_BT"].set_sensitive(False)
    //     objekt["max_count_step_LB"].set_sensitive(False)
    //     objekt["I_MAX_COUNT_STEP_SB"].set_sensitive(False)
    //   else:
    //     objekt["calibration_BT"].set_sensitive(True)           
    //     objekt["max_count_step_LB"].set_sensitive(True)
    //     objekt["I_MAX_COUNT_STEP_SB"].set_sensitive(True)
    // elif (name == "I_SHOW_CUT_XY_CB"):
    //   if (value):
    //     objekt["I_SHOW_CUBE_POSITION_CB"].set_sensitive(True)
    //   else:
    //     objekt["I_SHOW_CUBE_POSITION_CB"].set_sensitive(False)
    // 
    // sm.write_int(pix[name], value)

    //   unlock(pix_semid, 0);
}

void
change_input_file_BT_clicked(
    GtkWidget * widget)
{
    GladeXML *input_FS_xml;
    GtkWidget *input_FS;
    GtkWidget *input_file_RB = glade_xml_get_widget(xml, "input_file_RB");
    GtkWidget *I_INPUT_RB = glade_xml_get_widget(xml, "I_INPUT_RB");
    char *p_filename;

    if ((input_FS_xml = glade_xml_new(glade_xml, "input_FS", NULL)) == NULL) {
        g_warning("glade_xml_new() failure");
        exit(EXIT_FAILURE);
    }

    glade_xml_signal_autoconnect(input_FS_xml);
    input_FS = glade_xml_get_widget(input_FS_xml, "input_FS");

    while (1) {
        if (gtk_dialog_run((GtkDialog *) input_FS) == GTK_RESPONSE_OK) {
            p_filename =
                (char *)
                gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(input_FS));

            if (file_exist(p_filename)) {
                lock(pix_semid, 0);
                strcpy(p_pix_sm->str_soubor_in, p_filename);
                unlock(pix_semid, 0);

                gtk_widget_set_sensitive(input_file_RB, TRUE);
                gtk_toggle_button_set_active(input_file_RB, TRUE);
            }
            else {
                gtk_widget_set_sensitive(input_file_RB, FALSE);
                gtk_toggle_button_set_active(I_INPUT_RB, TRUE);
            }

        }
        else {
            break;
        }
    }

    gtk_widget_destroy(input_FS);
}

void
focus_in_event(
    GtkWidget * widget,
    GdkEvent * event)
{
    gtk_widget_modify_fg(widget, GTK_STATE_NORMAL, &red_color);
}

void
focus_out_event(
    GtkWidget * widget,
    GdkEvent * event)
{
    gtk_widget_modify_fg(widget, GTK_STATE_NORMAL, &black_color);
}

void
quit(
    GtkWidget * widget)
{
    gtk_main_quit();
}

/* Signal handler functions end */

/********************************/

static void
help(
    char *p_name)
{
    printf("Usage: %s [options]\n\n", p_name);
    printf("Options:\n");
    printf("-h, --help       display this help and exit\n");
    printf("    --version    output version information and exit\n");
}

//void print_item(gpointer data, gpointer user_data)
//{
//    printf("%s\n", glade_get_widget_name((GtkWidget *)data));
//}

static void
run_long_option(
    const char *option,
    const char *optarg)
{
    if (!strcmp(option, "version")) {
        printf("OPSO control (%s, %s)\n", __TIME__, __DATE__);
        printf("Written by Jan Fuchs <fuky@sunstel.asu.cas.cz>\n\n");
        printf("Copyright (C) 2008 Free Software Foundation, Inc.\n");
        printf
            ("This is free software; see the source for copying conditions.  There is NO\n");
        printf
            ("warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n");
    }

    exit(EXIT_SUCCESS);
}

int
main(
    int argc,
    char *argv[])
{
    while (1) {
        int o;
        int option_index = 0;
        static struct option long_options[] = {
            {"help", 0, 0, 'h'},
            {"version", 0, 0, 0},
            {0, 0, 0, 0}
        };

        o = getopt_long(argc, argv, "h", long_options, &option_index);
        if (o == -1) {
            break;
        }

        switch (o) {
        case 0:
            run_long_option(long_options[option_index].name, optarg);
            break;

        case 'h':
            help(argv[0]);
            exit(EXIT_SUCCESS);
            break;

        case '?':
            break;

        default:
            break;
        }
    }

    openlog("control", LOG_PID | LOG_CONS, LOG_LOCAL0);
    syslog(LOG_INFO, "RUN control");

    if (!file_exist(PID_PATH "opso.pid")) {
        syslog(LOG_ERR, "ERROR opso not runing");
        syslog(LOG_ERR, "exiting");
        exit(EXIT_FAILURE);
    }

    write_pid("control", getpid());
    ipc_create();

    gtk_init(&argc, &argv);

    gdk_color_parse("#FF0000", &red_color);
    gdk_color_parse("#000000", &black_color);

    if ((xml = glade_xml_new(glade_xml, "window", NULL)) == NULL) {
        g_warning("glade_xml_new() failure");
        exit(EXIT_FAILURE);
    }

    glade_xml_signal_autoconnect(xml);

    //p_widgets_list = glade_xml_get_widget_prefix(xml, "");
    //g_list_foreach(p_widgets_list, print_item, NULL);

    gtk_window_set_title(GET_WINDOW("window"), "OPSO Control");

    gtk_main();

    return 0;
}
