#!/usr/bin/python -d
# -*- coding: utf-8 -*-

# $Date: 08:40 20.02. 2006$

import sys

pole = [ "I_BRIGHTNESS_SL",
         "I_CONTRAST_SL",
         "I_CUT_X_SL",
         "I_CUT_Y_SL",
         "I_CUT_X_SIZE_SL",
         "I_CUT_Y_SIZE_SL",
         "I_CUT_Y_SLITH_SIZE_SL",
         "I_TARGET_X_SL",
         "I_TARGET_Y_SL",
         "I_ZOOM_X_SL",
         "I_ZOOM_Y_SL",
         "I_ZOOM_SIZE_SL",
         "I_ZOOM_CUT_X_SL",
         "I_ZOOM_CUT_Y_SL",
         "I_ZOOM_CUT_X_SIZE_SL",
         "I_ZOOM_CUT_Y_SIZE_SL",
         "I_FAULTY_PIX_X_SL",
         "I_FAULTY_PIX_Y_SL",
         "I_FAULTY_PIX_SIZE_SL",
         "I_CUT_ALL_LINES_ZOOM_CB",
         "I_AVERAGE_SL",
         "I_SLITH_BEGIN_SL",
         "I_SLITH_END_SL",
         "I_ZOOM_CB",
         "I_ZOOM_CUT_CB",
         "I_ZOOM_BIND_TARGET_CB",
         "I_TARGET_CB",
         "I_SHOW_CURSOR_SLITH_CB",
         "I_SHOW_CURSOR_CUT_XY_CB",
         "I_SHOW_CURSOR_ZOOM_CB",
         "I_SHOW_CURSOR_ZOOM_CUT_CB",
         "I_SHOW_CUT_XY_CB",
         "I_SHOW_FIT_GAUS_XY_CB",
         "I_SHOW_CUBE_POSITION_CB",
         "I_SHOW_VALUE_IN_QUADRANT_CB",
         "I_SHOW_FAULTY_PIX_CB",
         "I_SHOW_CURSOR_FAULTY_PIX_CB",
         "I_BLACKEN_FAULTY_PIX_CB",
         "I_HISTOGRAM_CB",
         "I_TIMEOUT_TSGC_SB",
         "I_MIN_INTENZITY_STAR_SB",
         "I_MAX_FWHM_STAR_SB",
         "I_CORR_AT_ERROR_SB",
         "I_ALLOWED_OFFSET_SB",
         "I_TIMEOUT_ALLOWED_OFFSET_SB",
         "I_SEC_IN_PIX_SB",
         "I_BEGIN_STAR_SB",
         "I_PERMISSIBLE_DEVIATION_SB",
         "I_COUNT_STEP_SB",
         "I_MAX_COUNT_STEP_SB",
         "I_AUTOMATION_POINTING_TB",
         "I_SAVE_TB",
         "I_SLIDING_AVERAGE_RB",
         "I_INPUT_RB",
         "I_CALIBRATION",
         "I_ZMENA_PRU",
         "I_KOSTKA_START_X",
         "I_KOSTKA_START_Y",
         "P_POLE_FAULTY_PIX",
         "S_SOUBOR_IN",
         "S_SOUBOR_OUT" ]

# C
soubor = open("pix.h", "w")

soubor.write("""\
/* Generated automatically from %s. DO NOT EDIT. */

#ifndef __PIX_H
#define __PIX_H

#define FAULTY_PIX_MAX 20

typedef struct {
""" % sys.argv[0])

for polozka in pole:
    datovy_typ = polozka[0]
    objekt = polozka[-2:]
    
    if (objekt in ["SL", "TB", "SB", "CB", "RB"]):
      nazev = polozka[2:-2]
    else:
      nazev = polozka[2:]
      objekt = ""
      
    if (datovy_typ == "I"):
      soubor.write("  int %s%s;\n" % (nazev.lower(), objekt))

soubor.write("""\
  int pole_faulty_pix[FAULTY_PIX_MAX][3];
  char str_soubor_in[MAX_LEN_FILE_NAME];
  char str_soubor_out[MAX_LEN_FILE_NAME];
} PIX;
    
""")

soubor.write("enum {\n")

for polozka in pole:
  soubor.write("  PIX_%s,\n" % polozka)

soubor.write("};\n\n")
soubor.write("#endif\n")
soubor.close()

# Python
soubor = open("./python/lib/pix.py", "w")

soubor.write("""\
#!/usr/bin/python -d
# -*- coding: utf-8 -*-

# Generated automatically from %s. DO NOT EDIT.

pix = {
""" % sys.argv[0])

i = 0
for polozka in pole:
  soubor.write("  '%s': %i,\n" % (polozka, i))
  i += 1

soubor.write("}")
soubor.close()
