/**
  * Author: Jan Fuchs
  * $Date: 2009-04-02 14:10:26 +0200 (Thu, 02 Apr 2009) $
  * $Rev: 8 $
 */

#ifndef __IPC_H
#define __IPC_H

#include "pix.h"
#include "ccbuf.h"

#if defined(__GNU_LIBRARY__) && !defined(_SEM_SEMUN_UNDEFINED)
/* union semun is defined by including <sys/sem.h> */
#else
/* according to X/OPEN we have to define it ourselves */
union semun {
      int val;                  /* value for SETVAL             */
      struct semid_ds *buf;     /* buffer for IPC_STAT, IPC_SET */
      unsigned short *array;    /* array for GETALL, SETALL     */
                                /* Linux specific part:         */
      struct seminfo *__buf;    /* buffer for IPC_INFO          */
};
#endif

extern PIX *p_pix_sm;
extern CCBUF *p_ccbuf_sm;

extern int pix_shmid;
extern int pix_semid;
extern int ccbuf_shmid;
extern int ccbuf_semid;

void lock (int semid, int num);
void unlock (int semid, int num);
void ipc_create (void);
void ipc_remove (void);

#endif
