#include <Python.h>

#include "global.h"
#include "ipc.h"
#include "pix.h"

PIX pix;

PyObject *py_read_int(
    PyObject * self,
    PyObject * args);
PyObject *py_write_int(
    PyObject * self,
    PyObject * args);
PyObject *py_read_array(
    PyObject * self,
    PyObject * args);
PyObject *py_write_array(
    PyObject * self,
    PyObject * args);
PyObject *py_read_str(
    PyObject * self,
    PyObject * args);
PyObject *py_write_str(
    PyObject * self,
    PyObject * args);
PyObject *py_remove(
    PyObject * self,
    PyObject * args);
void initsm(
    void);

/**
  *
 */
PyObject *
py_read_int(
    PyObject * self,
    PyObject * args)
{
    int py_promena;

    lock(pix_semid, 0);
    pix = *p_pix_sm;
    unlock(pix_semid, 0);

    if (!PyArg_ParseTuple(args, "i", &py_promena))
        return NULL;

    switch (py_promena) {
    case PIX_I_BRIGHTNESS_SL:
        return Py_BuildValue("i", pix.brightness_SL);
        break;

    case PIX_I_CONTRAST_SL:
        return Py_BuildValue("i", pix.contrast_SL);
        break;

    case PIX_I_SLITH_BEGIN_SL:
        return Py_BuildValue("i", pix.slith_begin_SL);
        break;

    case PIX_I_SLITH_END_SL:
        return Py_BuildValue("i", pix.slith_end_SL);
        break;

    case PIX_I_CUT_X_SL:
        return Py_BuildValue("i", pix.cut_x_SL);
        break;

    case PIX_I_CUT_X_SIZE_SL:
        return Py_BuildValue("i", pix.cut_x_size_SL);
        break;

    case PIX_I_CUT_Y_SL:
        return Py_BuildValue("i", pix.cut_y_SL);
        break;

    case PIX_I_CUT_Y_SIZE_SL:
        return Py_BuildValue("i", pix.cut_y_size_SL);
        break;

    case PIX_I_CUT_Y_SLITH_SIZE_SL:
        return Py_BuildValue("i", pix.cut_y_slith_size_SL);
        break;

    case PIX_I_TARGET_X_SL:
        return Py_BuildValue("i", pix.target_x_SL);
        break;

    case PIX_I_TARGET_Y_SL:
        return Py_BuildValue("i", pix.target_y_SL);
        break;

    case PIX_I_ZOOM_X_SL:
        return Py_BuildValue("i", pix.zoom_x_SL);
        break;

    case PIX_I_ZOOM_Y_SL:
        return Py_BuildValue("i", pix.zoom_y_SL);
        break;

    case PIX_I_ZOOM_SIZE_SL:
        return Py_BuildValue("i", pix.zoom_size_SL);
        break;

    case PIX_I_ZOOM_CUT_X_SL:
        return Py_BuildValue("i", pix.zoom_cut_x_SL);
        break;

    case PIX_I_ZOOM_CUT_Y_SL:
        return Py_BuildValue("i", pix.zoom_cut_y_SL);
        break;

    case PIX_I_ZOOM_CUT_X_SIZE_SL:
        return Py_BuildValue("i", pix.zoom_cut_x_size_SL);
        break;

    case PIX_I_ZOOM_CUT_Y_SIZE_SL:
        return Py_BuildValue("i", pix.zoom_cut_y_size_SL);
        break;

    case PIX_I_FAULTY_PIX_X_SL:
        return Py_BuildValue("i", pix.faulty_pix_x_SL);
        break;

    case PIX_I_FAULTY_PIX_Y_SL:
        return Py_BuildValue("i", pix.faulty_pix_y_SL);
        break;

    case PIX_I_FAULTY_PIX_SIZE_SL:
        return Py_BuildValue("i", pix.faulty_pix_size_SL);
        break;

    case PIX_I_CUT_ALL_LINES_ZOOM_CB:
        return Py_BuildValue("i", pix.cut_all_lines_zoom_CB);
        break;

    case PIX_I_AVERAGE_SL:
        return Py_BuildValue("i", pix.average_SL);
        break;

    case PIX_I_ZOOM_CB:
        return Py_BuildValue("i", pix.zoom_CB);
        break;

    case PIX_I_ZOOM_CUT_CB:
        return Py_BuildValue("i", pix.zoom_cut_CB);
        break;

    case PIX_I_TARGET_CB:
        return Py_BuildValue("i", pix.target_CB);
        break;

    case PIX_I_SHOW_CURSOR_SLITH_CB:
        return Py_BuildValue("i", pix.show_cursor_slith_CB);
        break;

    case PIX_I_SHOW_CURSOR_CUT_XY_CB:
        return Py_BuildValue("i", pix.show_cursor_cut_xy_CB);
        break;

    case PIX_I_SHOW_CURSOR_ZOOM_CB:
        return Py_BuildValue("i", pix.show_cursor_zoom_CB);
        break;

    case PIX_I_SHOW_CURSOR_ZOOM_CUT_CB:
        return Py_BuildValue("i", pix.show_cursor_zoom_cut_CB);
        break;

    case PIX_I_SHOW_CUT_XY_CB:
        return Py_BuildValue("i", pix.show_cut_xy_CB);
        break;

    case PIX_I_SHOW_FIT_GAUS_XY_CB:
        return Py_BuildValue("i", pix.show_fit_gaus_xy_CB);
        break;

    case PIX_I_SHOW_CUBE_POSITION_CB:
        return Py_BuildValue("i", pix.show_cube_position_CB);
        break;

    case PIX_I_SHOW_VALUE_IN_QUADRANT_CB:
        return Py_BuildValue("i", pix.show_value_in_quadrant_CB);
        break;

    case PIX_I_SHOW_FAULTY_PIX_CB:
        return Py_BuildValue("i", pix.show_faulty_pix_CB);
        break;

    case PIX_I_SHOW_CURSOR_FAULTY_PIX_CB:
        return Py_BuildValue("i", pix.show_cursor_faulty_pix_CB);
        break;

    case PIX_I_BLACKEN_FAULTY_PIX_CB:
        return Py_BuildValue("i", pix.blacken_faulty_pix_CB);
        break;

    case PIX_I_HISTOGRAM_CB:
        return Py_BuildValue("i", pix.histogram_CB);
        break;

    case PIX_I_BEGIN_STAR_SB:
        return Py_BuildValue("i", pix.begin_star_SB);
        break;

    case PIX_I_TIMEOUT_TSGC_SB:
        return Py_BuildValue("i", pix.timeout_tsgc_SB);
        break;

    case PIX_I_MIN_INTENZITY_STAR_SB:
        return Py_BuildValue("i", pix.min_intenzity_star_SB);
        break;

    case PIX_I_MAX_FWHM_STAR_SB:
        return Py_BuildValue("i", pix.max_fwhm_star_SB);
        break;

    case PIX_I_CORR_AT_ERROR_SB:
        return Py_BuildValue("i", pix.corr_at_error_SB);
        break;

    case PIX_I_ALLOWED_OFFSET_SB:
        return Py_BuildValue("i", pix.allowed_offset_SB);
        break;

    case PIX_I_TIMEOUT_ALLOWED_OFFSET_SB:
        return Py_BuildValue("i", pix.timeout_allowed_offset_SB);
        break;

    case PIX_I_SEC_IN_PIX_SB:
        return Py_BuildValue("i", pix.sec_in_pix_SB);
        break;

    case PIX_I_PERMISSIBLE_DEVIATION_SB:
        return Py_BuildValue("i", pix.permissible_deviation_SB);
        break;

    case PIX_I_COUNT_STEP_SB:
        return Py_BuildValue("i", pix.count_step_SB);
        break;

    case PIX_I_MAX_COUNT_STEP_SB:
        return Py_BuildValue("i", pix.max_count_step_SB);
        break;

    case PIX_I_AUTOMATION_POINTING_TB:
        return Py_BuildValue("i", pix.automation_pointing_TB);
        break;

    case PIX_I_SAVE_TB:
        return Py_BuildValue("i", pix.save_TB);
        break;

    case PIX_I_SLIDING_AVERAGE_RB:
        return Py_BuildValue("i", pix.sliding_average_RB);
        break;

    case PIX_I_INPUT_RB:
        return Py_BuildValue("i", pix.input_RB);
        break;

    case PIX_I_CALIBRATION:
        return Py_BuildValue("i", pix.calibration);
        break;

    case PIX_I_KOSTKA_START_X:
        return Py_BuildValue("i", pix.kostka_start_x);
        break;

    case PIX_I_KOSTKA_START_Y:
        return Py_BuildValue("i", pix.kostka_start_y);
        break;

    case PIX_I_ZMENA_PRU:
        return Py_BuildValue("i", pix.zmena_pru);
        break;

    default:
        break;
    }

    return Py_BuildValue("i", -1);
}

/**
  *
 */
PyObject *
py_write_int(
    PyObject * self,
    PyObject * args)
{
    int py_promena;
    int py_hodnota;
    int navratova_hodnota = 0;

    if (!PyArg_ParseTuple(args, "ii", &py_promena, &py_hodnota))
        return NULL;

    lock(pix_semid, 0);
    switch (py_promena) {
    case PIX_I_BRIGHTNESS_SL:
        p_pix_sm->brightness_SL = py_hodnota;
        break;

    case PIX_I_CONTRAST_SL:
        p_pix_sm->contrast_SL = py_hodnota;
        break;

    case PIX_I_SLITH_BEGIN_SL:
        p_pix_sm->slith_begin_SL = py_hodnota;
        break;

    case PIX_I_SLITH_END_SL:
        p_pix_sm->slith_end_SL = py_hodnota;
        break;

    case PIX_I_CUT_X_SL:
        p_pix_sm->cut_x_SL = py_hodnota;
        break;

    case PIX_I_CUT_X_SIZE_SL:
        p_pix_sm->cut_x_size_SL = py_hodnota;
        break;

    case PIX_I_CUT_Y_SL:
        p_pix_sm->cut_y_SL = py_hodnota;
        break;

    case PIX_I_CUT_Y_SIZE_SL:
        p_pix_sm->cut_y_size_SL = py_hodnota;
        break;

    case PIX_I_CUT_Y_SLITH_SIZE_SL:
        p_pix_sm->cut_y_slith_size_SL = py_hodnota;
        break;

    case PIX_I_TARGET_X_SL:
        p_pix_sm->target_x_SL = py_hodnota;
        break;

    case PIX_I_TARGET_Y_SL:
        p_pix_sm->target_y_SL = py_hodnota;
        break;

    case PIX_I_ZOOM_X_SL:
        p_pix_sm->zoom_x_SL = py_hodnota;
        break;

    case PIX_I_ZOOM_Y_SL:
        p_pix_sm->zoom_y_SL = py_hodnota;
        break;

    case PIX_I_ZOOM_SIZE_SL:
        p_pix_sm->zoom_size_SL = py_hodnota;
        break;

    case PIX_I_ZOOM_CUT_X_SL:
        p_pix_sm->zoom_cut_x_SL = py_hodnota;
        break;

    case PIX_I_ZOOM_CUT_Y_SL:
        p_pix_sm->zoom_cut_y_SL = py_hodnota;
        break;

    case PIX_I_ZOOM_CUT_X_SIZE_SL:
        p_pix_sm->zoom_cut_x_size_SL = py_hodnota;
        break;

    case PIX_I_ZOOM_CUT_Y_SIZE_SL:
        p_pix_sm->zoom_cut_y_size_SL = py_hodnota;
        break;

    case PIX_I_FAULTY_PIX_X_SL:
        p_pix_sm->faulty_pix_x_SL = py_hodnota;
        break;

    case PIX_I_FAULTY_PIX_Y_SL:
        p_pix_sm->faulty_pix_y_SL = py_hodnota;
        break;

    case PIX_I_FAULTY_PIX_SIZE_SL:
        p_pix_sm->faulty_pix_size_SL = py_hodnota;
        break;

    case PIX_I_CUT_ALL_LINES_ZOOM_CB:
        p_pix_sm->cut_all_lines_zoom_CB = py_hodnota;
        break;

    case PIX_I_AVERAGE_SL:
        p_pix_sm->average_SL = py_hodnota;
        break;

    case PIX_I_ZOOM_CB:
        p_pix_sm->zoom_CB = py_hodnota;
        break;

    case PIX_I_ZOOM_CUT_CB:
        p_pix_sm->zoom_cut_CB = py_hodnota;
        break;

    case PIX_I_TARGET_CB:
        p_pix_sm->target_CB = py_hodnota;
        break;

    case PIX_I_SHOW_CURSOR_SLITH_CB:
        p_pix_sm->show_cursor_slith_CB = py_hodnota;
        break;

    case PIX_I_SHOW_CURSOR_CUT_XY_CB:
        p_pix_sm->show_cursor_cut_xy_CB = py_hodnota;
        break;

    case PIX_I_SHOW_CURSOR_ZOOM_CB:
        p_pix_sm->show_cursor_zoom_CB = py_hodnota;
        break;

    case PIX_I_SHOW_CURSOR_ZOOM_CUT_CB:
        p_pix_sm->show_cursor_zoom_cut_CB = py_hodnota;
        break;

    case PIX_I_SHOW_CUT_XY_CB:
        p_pix_sm->show_cut_xy_CB = py_hodnota;
        break;

    case PIX_I_SHOW_FIT_GAUS_XY_CB:
        p_pix_sm->show_fit_gaus_xy_CB = py_hodnota;
        break;

    case PIX_I_SHOW_CUBE_POSITION_CB:
        p_pix_sm->show_cube_position_CB = py_hodnota;
        break;

    case PIX_I_SHOW_VALUE_IN_QUADRANT_CB:
        p_pix_sm->show_value_in_quadrant_CB = py_hodnota;
        break;

    case PIX_I_SHOW_FAULTY_PIX_CB:
        p_pix_sm->show_faulty_pix_CB = py_hodnota;
        break;

    case PIX_I_SHOW_CURSOR_FAULTY_PIX_CB:
        p_pix_sm->show_cursor_faulty_pix_CB = py_hodnota;
        break;

    case PIX_I_BLACKEN_FAULTY_PIX_CB:
        p_pix_sm->blacken_faulty_pix_CB = py_hodnota;
        break;

    case PIX_I_HISTOGRAM_CB:
        p_pix_sm->histogram_CB = py_hodnota;
        break;

    case PIX_I_BEGIN_STAR_SB:
        p_pix_sm->begin_star_SB = py_hodnota;
        break;

    case PIX_I_TIMEOUT_TSGC_SB:
        p_pix_sm->timeout_tsgc_SB = py_hodnota;
        break;

    case PIX_I_MIN_INTENZITY_STAR_SB:
        p_pix_sm->min_intenzity_star_SB = py_hodnota;
        break;

    case PIX_I_MAX_FWHM_STAR_SB:
        p_pix_sm->max_fwhm_star_SB = py_hodnota;
        break;

    case PIX_I_CORR_AT_ERROR_SB:
        p_pix_sm->corr_at_error_SB = py_hodnota;
        break;

    case PIX_I_ALLOWED_OFFSET_SB:
        p_pix_sm->allowed_offset_SB = py_hodnota;
        break;

    case PIX_I_TIMEOUT_ALLOWED_OFFSET_SB:
        p_pix_sm->timeout_allowed_offset_SB = py_hodnota;
        break;

    case PIX_I_SEC_IN_PIX_SB:
        p_pix_sm->sec_in_pix_SB = py_hodnota;
        break;

    case PIX_I_PERMISSIBLE_DEVIATION_SB:
        p_pix_sm->permissible_deviation_SB = py_hodnota;
        break;

    case PIX_I_COUNT_STEP_SB:
        p_pix_sm->count_step_SB = py_hodnota;
        break;

    case PIX_I_AUTOMATION_POINTING_TB:
        p_pix_sm->automation_pointing_TB = py_hodnota;
        break;

    case PIX_I_SAVE_TB:
        p_pix_sm->save_TB = py_hodnota;
        break;

    case PIX_I_SLIDING_AVERAGE_RB:
        p_pix_sm->sliding_average_RB = py_hodnota;
        break;

    case PIX_I_INPUT_RB:
        p_pix_sm->input_RB = py_hodnota;
        break;

    case PIX_I_CALIBRATION:
        p_pix_sm->calibration = py_hodnota;
        break;

    case PIX_I_KOSTKA_START_X:
        p_pix_sm->kostka_start_x = py_hodnota;
        break;

    case PIX_I_KOSTKA_START_Y:
        p_pix_sm->kostka_start_y = py_hodnota;
        break;

    case PIX_I_ZMENA_PRU:
        p_pix_sm->zmena_pru = py_hodnota;
        break;

    default:
        navratova_hodnota = -1;
        break;
    }
    unlock(pix_semid, 0);

    return Py_BuildValue("i", navratova_hodnota);
}

/**
  *
 */
PyObject *
py_read_str(
    PyObject * self,
    PyObject * args)
{
    int py_promena;

    if (!PyArg_ParseTuple(args, "i", &py_promena))
        return NULL;

    switch (py_promena) {
    case PIX_S_SOUBOR_IN:
        return Py_BuildValue("s", p_pix_sm->str_soubor_in);
        break;

    case PIX_S_SOUBOR_OUT:
        return Py_BuildValue("s", p_pix_sm->str_soubor_out);
        break;

    default:
        break;
    }

    return Py_BuildValue("s", "error");
}

/**
  *
 */
PyObject *
py_read_array(
    PyObject * self,
    PyObject * args)
{
    int py_promena;
    int py_x;
    int py_y;

    if (!PyArg_ParseTuple(args, "iii", &py_promena, &py_x, &py_y))
        return NULL;

    switch (py_promena) {
    case PIX_P_POLE_FAULTY_PIX:
        return Py_BuildValue("i", p_pix_sm->pole_faulty_pix[py_x][py_y]);
        break;

    default:
        break;
    }

    return Py_BuildValue("i", -1);
}

/**
  *
 */
PyObject *
py_write_array(
    PyObject * self,
    PyObject * args)
{
    int py_promena;
    int py_x;
    int py_y;
    int py_hodnota;
    int navratova_hodnota = 0;

    if (!PyArg_ParseTuple
        (args, "iiii", &py_promena, &py_x, &py_y, &py_hodnota))
        return NULL;

    switch (py_promena) {
    case PIX_P_POLE_FAULTY_PIX:
        p_pix_sm->pole_faulty_pix[py_x][py_y] = py_hodnota;
        break;

    default:
        navratova_hodnota = -1;
        break;
    }

    return Py_BuildValue("i", navratova_hodnota);
}

/**
  *
 */
PyObject *
py_write_str(
    PyObject * self,
    PyObject * args)
{
    int py_promena;
    char *py_hodnota;
    int navratova_hodnota = 0;

    if (!PyArg_ParseTuple(args, "is", &py_promena, &py_hodnota))
        return NULL;

    switch (py_promena) {
    case PIX_S_SOUBOR_IN:
        strcpy(p_pix_sm->str_soubor_in, py_hodnota);
        break;

    case PIX_S_SOUBOR_OUT:
        strcpy(p_pix_sm->str_soubor_out, py_hodnota);
        break;

    default:
        navratova_hodnota = -1;
        break;
    }

    return Py_BuildValue("i", navratova_hodnota);
}

/**
  *
 */
PyObject *
py_remove(
    PyObject * self,
    PyObject * args)
{
    ipc_remove();
    return Py_BuildValue("i", 0);
}

PyMethodDef sm_methods[] = {
    {"read_int", (PyCFunction) py_read_int, METH_VARARGS, NULL}
    ,
    {"write_int", (PyCFunction) py_write_int, METH_VARARGS, NULL}
    ,
    {"read_array", (PyCFunction) py_read_array, METH_VARARGS, NULL}
    ,
    {"write_array", (PyCFunction) py_write_array, METH_VARARGS, NULL}
    ,
    {"read_str", (PyCFunction) py_read_str, METH_VARARGS, NULL}
    ,
    {"write_str", (PyCFunction) py_write_str, METH_VARARGS, NULL}
    ,
    {"remove", (PyCFunction) py_remove, METH_NOARGS, NULL}
    ,
    {NULL, NULL}
};

/**
  *
 */
void
initsm(
    void)
{
    ipc_create();
    Py_InitModule("sm", sm_methods);
}
