#!/usr/bin/python2.4 -d
# -*- coding: utf-8 -*-

import gtk
import gtk.glade
import gobject
import gettext
import getopt
import os
import sys
import time
import signal
import syslog

import sm
from pix import pix

__author__ = 'Jan Fuchs'
__date__ = '$Date: 2009-04-08 18:55:31 +0200 (Wed, 08 Apr 2009) $'
__version__ = '$Rev: 14 $'

VWIDTH = 640
VHEIGHT = 576
FAULTY_PIX_MAX = 20

cesta = { "share": "../../share",
          "po":    "/cesta" }

objekt = {}

target_popis = { "name": "",
                 "x": 0,
                 "y": 0 }
                         
target = []

gettext.bindtextdomain("opso", cesta["po"])
gettext.textdomain("opso")
gtk.glade.bindtextdomain("opso", cesta["po"])
gtk.glade.textdomain("opso")
_ = gettext.gettext
 
color_red = gtk.gdk.color_parse("#FFCCCC")
color_green = gtk.gdk.color_parse("#CCFFCC")

def napoveda():
  print _("""\

Arguments:
-h, --help
-x            window position
-y            window position

    --version\
      
  """)
  
def version():
  print "%s, %s" % (__version__, __date__)
    
class Okno:
  log_buffer = None
  pix = None
  conf_faulty_pix = ""
  count_faulty_pix = 0
  target_slit = { "x": 0, "y": 0 }
  target_field = { "x": 0, "y": 0 }
  
  def __init__(self, x, y):
    self.xml = gtk.glade.XML("%s/opso.glade" % (cesta["share"]), "window")
    self.xml.signal_autoconnect(self)
    self.xml.get_widget("window").set_uposition(x, y)

    for widget in self.xml.get_widget_prefix(""):
      objekt.update({widget.get_name(): widget})

    objekt["camera_OM"].set_menu(self.camera_menu())
    objekt["target_OM"].set_menu(self.target_menu())
    objekt["settings_OM"].set_menu(self.settings_menu())

    self.log_buffer = objekt["log_TV"].get_buffer()
      
    tag = self.log_buffer.create_tag('info')
    tag.set_property('foreground', '#000000')
     
    tag = self.log_buffer.create_tag('error')
    tag.set_property('foreground', '#FF0000')
    
    self.default()
    objekt["input_field_RB"].set_sensitive(False)
    
    gtk.main()

  def zoom_bind_target(self, name, value):
    if (objekt["I_ZOOM_BIND_TARGET_CB"].get_active()):
      if (name == "I_TARGET_X_SL"):
        objekt["I_ZOOM_X_SL"].set_value(value)
      elif (name == "I_TARGET_Y_SL"):
        objekt["I_ZOOM_Y_SL"].set_value(value)
      elif (name == "I_ZOOM_X_SL"):
        objekt["I_TARGET_X_SL"].set_value(value)
      elif (name == "I_ZOOM_Y_SL"):
        objekt["I_TARGET_Y_SL"].set_value(value)

  def set(self, name, value):
    old_value = sm.read_int(pix[name])

    self.zoom_bind_target(name, value)

    if ((name == "I_TARGET_X_SL") and
        ((value >= VWIDTH - objekt["I_ZOOM_SIZE_SL"].get_value() / 2) or
         (value <= objekt["I_ZOOM_SIZE_SL"].get_value() / 2))):
      objekt[name].set_value(old_value)
      return
    elif ((name in ["I_SLITH_BEGIN_SL", "I_SLITH_END_SL"]) and
          (objekt["I_SLITH_BEGIN_SL"].get_value() >= objekt["I_SLITH_END_SL"].get_value())):
      objekt[name].set_value(old_value)
      return
    elif ((name == "I_TARGET_Y_SL") and
          ((value >= VHEIGHT - objekt["I_ZOOM_SIZE_SL"].get_value() / 2) or
           (value <= objekt["I_ZOOM_SIZE_SL"].get_value() / 2))):
      objekt[name].set_value(old_value)
      return
    elif ((name == "I_ZOOM_X_SL") and
          ((value >= VWIDTH - objekt["I_ZOOM_SIZE_SL"].get_value() / 2) or
           (value <= objekt["I_ZOOM_SIZE_SL"].get_value() / 2))):
      objekt[name].set_value(old_value)
      return
    elif ((name == "I_ZOOM_Y_SL") and
          ((value >= VHEIGHT - objekt["I_ZOOM_SIZE_SL"].get_value() / 2) or
           (value <= objekt["I_ZOOM_SIZE_SL"].get_value() / 2))):
      objekt[name].set_value(old_value)
      return
    elif ((name == "I_ZOOM_SIZE_SL") and
          (value > sm.read_int(pix[name])) and
          ((value / 2 + objekt["I_ZOOM_X_SL"].get_value() >= VWIDTH) or
           (value / 2 + objekt["I_ZOOM_Y_SL"].get_value() >= VHEIGHT) or
           (value / 2 >= objekt["I_ZOOM_X_SL"].get_value()) or
           (value / 2 >= objekt["I_ZOOM_Y_SL"].get_value()))):
      objekt[name].set_value(old_value)
      return
    elif (((name == "I_ZOOM_CUT_X_SL") or (name == "I_ZOOM_CUT_X_SIZE_SL")) and
          ((objekt["I_ZOOM_CUT_X_SL"].get_value() + objekt["I_ZOOM_CUT_X_SIZE_SL"].get_value()) >= 255)):
      objekt[name].set_value(old_value)
      return
    elif (((name == "I_ZOOM_CUT_Y_SL") or (name == "I_ZOOM_CUT_Y_SIZE_SL")) and
          ((objekt["I_ZOOM_CUT_Y_SL"].get_value() + objekt["I_ZOOM_CUT_Y_SIZE_SL"].get_value()) >= 255)):
      objekt[name].set_value(old_value)
      return

    if (name == "I_TARGET_X_SL"):
      if (objekt["I_INPUT_RB"].get_active()):
        self.target_slit["x"] = value
      elif (not objekt["input_file_RB"].get_active()):
        self.target_field["x"] = value
    elif (name == "I_TARGET_Y_SL"):
      if (objekt["I_INPUT_RB"].get_active()):
        self.target_slit["y"] = value
      elif (not objekt["input_file_RB"].get_active()):
        self.target_field["y"] = value

    if (name == "I_AVERAGE_SL"):
      sm.write_int(pix[name], int(value))
      sm.write_int(pix["I_ZMENA_PRU"], 1)
    else:
      sm.write_int(pix[name], value)

    if (name == "I_MAX_COUNT_STEP_SB"):
      syslog.syslog(syslog.LOG_INFO, "Max. count step = %i" % value)
      sm.write_int(pix["I_CALIBRATION"], 1) 
 
  def kostka_start(self, osa):
    try:    
      fr = open("../../conf/kostka_start_%s" % (osa), "r")
    except IOError, chyba:
      syslog.syslog(syslog.LOG_ERR, str(chyba))

    start = int(fr.readline())
    fr.close()
    
    try:    
      fr = open("../../conf/kostka_%s" % (osa), "r")
    except IOError, chyba:
      syslog.syslog(syslog.LOG_ERR, str(chyba))

    pozice = int(fr.readline())
    fr.close()

    vysledek =  start - pozice + 100000

    try:    
      fw = open("../../conf/kostka_start_%s" % (osa), "w")
    except IOError, chyba:
      syslog.syslog(syslog.LOG_ERR, str(chyba))

    fw.write(str(vysledek))
    fw.close()
  
    return vysledek
 
  def default(self):
    sm.write_int(pix["I_KOSTKA_START_X"], self.kostka_start("0"));
    sm.write_int(pix["I_KOSTKA_START_Y"], self.kostka_start("1"));
    sm.write_int(pix["I_CALIBRATION"], 1) 

    self.automation_pointing_off(None)
    self.save_video_to_file_off(None)
    
    for polozka in pix.keys():
      if (objekt.has_key(polozka)):
        if (polozka[-2:] in ("SL", "SB")):
          objekt[polozka].set_value(sm.read_int(pix[polozka]))
        elif (polozka[-2:] in ("CB", "TB")):
          if (sm.read_int(pix[polozka])):
            objekt[polozka].set_active(True)
          else:
            objekt[polozka].set_active(False)
        elif (polozka == "I_SLIDING_AVERAGE_RB"):
          if (sm.read_int(pix[polozka])):
            objekt["I_SLIDING_AVERAGE_RB"].set_active(True)
          else:
            objekt["median_average_RB"].set_active(True)

  def read_faulty_pix(self):
    self.count_faulty_pix = 0
    for i in range(FAULTY_PIX_MAX):
      sm.write_array(pix["P_POLE_FAULTY_PIX"], i, 0, 0)
      sm.write_array(pix["P_POLE_FAULTY_PIX"], i, 1, 0)
      sm.write_array(pix["P_POLE_FAULTY_PIX"], i, 2, 0)

    try:
      soubor = open(self.conf_faulty_pix, 'r')
      for radek in soubor.readlines():
        pole = radek.split(":")      
        if (len(pole) == 3):
          try:
            sm.write_array(pix["P_POLE_FAULTY_PIX"], self.count_faulty_pix, 0, int(pole[0]))
            sm.write_array(pix["P_POLE_FAULTY_PIX"], self.count_faulty_pix, 1, int(pole[1]))
            sm.write_array(pix["P_POLE_FAULTY_PIX"], self.count_faulty_pix, 2, int(pole[2]))
            self.count_faulty_pix += 1
          except ValueError, chyba:
            syslog.syslog(syslog.LOG_INFO, "%s (%s)" % (self.conf_faulty_pix, str(chyba)))
            continue
      objekt["faulty_pix_OM"].set_menu(self.faulty_pix_menu())
      soubor.close()
    except IOError:
      syslog.syslog(syslog.LOG_INFO, "%s (neexistuje)" % self.conf_faulty_pix)
 
    self.kontrola_count_faulty_pix()
    
  def camera_menu(self):
    menu = gtk.Menu()

    polozka_MI = gtk.MenuItem("Field")
    group = polozka_MI
    menu.add(polozka_MI)
    polozka_MI.show()
    
    polozka_MI = gtk.MenuItem("Slit")
    group = polozka_MI
    menu.add(polozka_MI)
    polozka_MI.show()

    return menu

  def camera_changed(self, widget):
    if (widget.get_history() == 0):
      self.conf_faulty_pix = "../../conf/faulty_pix_field"
    elif (widget.get_history() == 1):
      self.conf_faulty_pix = "../../conf/faulty_pix_slit"
  
    self.read_faulty_pix()
    objekt["faulty_pix_OM"].set_menu(self.faulty_pix_menu())

  def target_menu(self):
    menu = gtk.Menu()

    for i in range(len(target)):
      polozka_MI = gtk.MenuItem(target[i]["name"])
      
      tt = gtk.Tooltips()
      tt.set_tip(polozka_MI, "Target X = %i\nTarget Y = %i" % (target[i]["x"], target[i]["y"]), None)
      tt.enable()
      
      group = polozka_MI
      menu.add(polozka_MI)
      polozka_MI.show()

    return menu

  def faulty_pix_menu(self):
    menu = gtk.Menu()

    for i in range(self.count_faulty_pix):
      polozka_MI = gtk.MenuItem("[%03i, %03i] - %03i" % \
          (sm.read_array(pix["P_POLE_FAULTY_PIX"], i, 0),
           sm.read_array(pix["P_POLE_FAULTY_PIX"], i, 1),
           sm.read_array(pix["P_POLE_FAULTY_PIX"], i, 2)))
      group = polozka_MI
      menu.add(polozka_MI)
      polozka_MI.show()

    return menu
  
  def focus_in_event(self, widget, event): 
    color = gtk.gdk.color_parse("#FF0000")
    widget.modify_fg(gtk.STATE_NORMAL, color)
    
  def focus_out_event(self, widget, event):
    color = gtk.gdk.color_parse("#000000")
    widget.modify_fg(gtk.STATE_NORMAL, color)

  def toggled(self, widget):
    name = widget.get_name()

    if (widget.get_active()):
      value = 1
    else:
      value = 0
    
    if (name == "I_SLIDING_AVERAGE_RB"):
      sm.write_int(pix["I_ZMENA_PRU"], 1)
    elif (name in ["I_INPUT_RB", "input_file_RB"]):
      name = "I_INPUT_RB"
      if (objekt["I_INPUT_RB"].get_active()):
        if (self.target_slit["x"] != 0):
          objekt["I_TARGET_X_SL"].set_value(self.target_slit["x"])
          objekt["I_TARGET_Y_SL"].set_value(self.target_slit["y"])
        value = 0
      elif (objekt["input_file_RB"].get_active()):
        value = 2
      else:
        if (self.target_field["x"] != 0):
          objekt["I_TARGET_X_SL"].set_value(self.target_field["x"])
          objekt["I_TARGET_Y_SL"].set_value(self.target_field["y"])
        value = 1
    elif (name == "I_ZOOM_BIND_TARGET_CB"):
      self.zoom_target_BT_clicked(None)
    #elif (name == "I_ZOOM_CB"):
    #  if (value):
    #    objekt["I_AUTOMATION_POINTING_TB"].set_sensitive(True)
    #    objekt["I_SHOW_VALUE_IN_QUADRANT_CB"].set_sensitive(True)
    #    #objekt["I_SHOW_FAULTY_PIX_CB"].set_active(False)
    #    #objekt["I_SHOW_CURSOR_FAULTY_PIX_CB"].set_active(False)
    #    #objekt["I_BLACKEN_FAULTY_PIX_CB"].set_active(False)
    #  else:
    #    objekt["I_AUTOMATION_POINTING_TB"].set_active(False)
    #    objekt["I_AUTOMATION_POINTING_TB"].set_sensitive(False)
    #    objekt["I_SHOW_VALUE_IN_QUADRANT_CB"].set_sensitive(False)
    elif (name == "I_SHOW_CUT_XY_CB"):
      if (value):
        objekt["I_SHOW_CUBE_POSITION_CB"].set_sensitive(True)
      else:
        objekt["I_SHOW_CUBE_POSITION_CB"].set_sensitive(False)
    
    sm.write_int(pix[name], value)
    
  def value_changed(self, widget):
    self.set(widget.get_name(), int(widget.get_value()))
    
  def automation_pointing_on(self, widget):
    objekt["calibration_BT"].set_sensitive(False)
    objekt["max_count_step_LB"].set_sensitive(False)
    objekt["I_MAX_COUNT_STEP_SB"].set_sensitive(False)
    objekt["timeout_TSGC_LB"].set_sensitive(False)
    objekt["I_TIMEOUT_TSGC_SB"].set_sensitive(False)
    objekt["automation_pointing_EB"].modify_bg(gtk.STATE_NORMAL, color_green)
    objekt["automation_pointing_LB"].set_text("ON")
    sm.write_int(pix["I_AUTOMATION_POINTING_TB"], 1)

  def automation_pointing_off(self, widget):
    objekt["calibration_BT"].set_sensitive(True)           
    objekt["max_count_step_LB"].set_sensitive(True)
    objekt["I_MAX_COUNT_STEP_SB"].set_sensitive(True)
    objekt["timeout_TSGC_LB"].set_sensitive(True)
    objekt["I_TIMEOUT_TSGC_SB"].set_sensitive(True)
    objekt["automation_pointing_EB"].modify_bg(gtk.STATE_NORMAL, color_red)
    objekt["automation_pointing_LB"].set_text("OFF")
    sm.write_int(pix["I_AUTOMATION_POINTING_TB"], 0)

  def save_video_to_file_timeout(self):
    self.save_video_to_file_off(None)
    return False

  def save_video_to_file_on(self, widget):
    xml_dialog = gtk.glade.XML("%s/opso.glade" % (cesta["share"]), "save_video_to_file_D")
    xml_dialog.signal_autoconnect(self)
    dialog = xml_dialog.get_widget("save_video_to_file_D")

    result = dialog.run()
    dialog.destroy()

    if (result == gtk.RESPONSE_OK):
      objekt["save_video_to_file_EB"].modify_bg(gtk.STATE_NORMAL, color_green)
      objekt["save_video_to_file_LB"].set_text("ON")
      sm.write_int(pix["I_SAVE_TB"], 1)
      gobject.timeout_add(120000, self.save_video_to_file_timeout)

  def save_video_to_file_off(self, widget):
    objekt["save_video_to_file_EB"].modify_bg(gtk.STATE_NORMAL, color_red)
    objekt["save_video_to_file_LB"].set_text("OFF")
    sm.write_int(pix["I_SAVE_TB"], 0)

  def zoom_target_BT_clicked(self, widget):
    self.set("I_ZOOM_X_SL", int(objekt["I_TARGET_X_SL"].get_value()))
    self.set("I_ZOOM_Y_SL", int(objekt["I_TARGET_Y_SL"].get_value()))

    #sm.write_int(pix["I_ZOOM_X_SL"], int(objekt["I_TARGET_X_SL"].get_value()))
    #sm.write_int(pix["I_ZOOM_Y_SL"], int(objekt["I_TARGET_Y_SL"].get_value()))

  def apply_default_settings(self):
    objekt["I_BRIGHTNESS_SL"].set_value(0)
    objekt["I_CONTRAST_SL"].set_value(255.0)
    objekt["I_AVERAGE_SL"].set_value(25)
    objekt["I_ZOOM_X_SL"].set_value(260)
    objekt["I_ZOOM_Y_SL"].set_value(260)
    objekt["I_ZOOM_SIZE_SL"].set_value(260)
    objekt["I_ZOOM_CUT_X_SL"].set_value(0)
    objekt["I_ZOOM_CUT_Y_SL"].set_value(0)
    objekt["I_ZOOM_CUT_X_SIZE_SL"].set_value(10)
    objekt["I_ZOOM_CUT_Y_SIZE_SL"].set_value(10)  
    objekt["I_CUT_X_SL"].set_value(300)
    objekt["I_CUT_Y_SL"].set_value(318)
    objekt["I_FAULTY_PIX_X_SL"].set_value(10)
    objekt["I_FAULTY_PIX_Y_SL"].set_value(10)
    objekt["I_FAULTY_PIX_SIZE_SL"].set_value(2)

    objekt["I_ZOOM_CB"].set_active(False)
    objekt["I_ZOOM_CUT_CB"].set_active(False)
    objekt["I_ZOOM_BIND_TARGET_CB"].set_active(True)
    objekt["I_CUT_ALL_LINES_ZOOM_CB"].set_active(False)
    objekt["I_TARGET_CB"].set_active(True)
    objekt["I_SHOW_CUT_XY_CB"].set_active(True)
    objekt["I_SHOW_FIT_GAUS_XY_CB"].set_active(True)
    objekt["I_SHOW_CURSOR_SLITH_CB"].set_active(False)
    objekt["I_SHOW_CURSOR_ZOOM_CB"].set_active(True)
    objekt["I_SHOW_CURSOR_ZOOM_CUT_CB"].set_active(False)
    objekt["I_SHOW_CURSOR_CUT_XY_CB"].set_active(False)
    objekt["I_SHOW_CUBE_POSITION_CB"].set_active(False)
    objekt["I_SHOW_VALUE_IN_QUADRANT_CB"].set_active(False)
    objekt["I_SHOW_FAULTY_PIX_CB"].set_active(False)
    objekt["I_SHOW_CURSOR_FAULTY_PIX_CB"].set_active(False)
    objekt["I_HISTOGRAM_CB"].set_active(True)
    objekt["I_BLACKEN_FAULTY_PIX_CB"].set_active(False)

    objekt["I_SLIDING_AVERAGE_RB"].set_active(True);

    objekt["I_COUNT_STEP_SB"].set_value(1)
    objekt["I_MAX_COUNT_STEP_SB"].set_value(50)
    objekt["I_PERMISSIBLE_DEVIATION_SB"].set_value(0)
    objekt["I_MIN_INTENZITY_STAR_SB"].set_value(0)
    objekt["I_MAX_FWHM_STAR_SB"].set_value(300)
    objekt["I_CORR_AT_ERROR_SB"].set_value(0)
    objekt["I_TIMEOUT_ALLOWED_OFFSET_SB"].set_value(5)

  def apply_settings_for_watec(self):
    self.apply_default_settings()

    objekt["I_TIMEOUT_TSGC_SB"].set_value(6)
    objekt["I_SLITH_BEGIN_SL"].set_value(0)
    objekt["I_SLITH_END_SL"].set_value(375)
    objekt["I_SLITH_BEGIN_SL"].set_value(336)
    objekt["I_SEC_IN_PIX_SB"].set_value(15)
    objekt["I_TARGET_X_SL"].set_value(357)
    objekt["I_TARGET_Y_SL"].set_value(300)
    objekt["I_ALLOWED_OFFSET_SB"].set_value(2)

    objekt["I_CUT_X_SL"].set_value(300)
    objekt["I_CUT_Y_SL"].set_value(357)
    objekt["I_CUT_X_SIZE_SL"].set_value(110)
    objekt["I_CUT_Y_SIZE_SL"].set_value(110)
    objekt["I_CUT_Y_SLITH_SIZE_SL"].set_value(34)

  def apply_settings_for_proxitronic(self):
    self.apply_default_settings()

    objekt["I_TIMEOUT_TSGC_SB"].set_value(3)
    objekt["I_SLITH_BEGIN_SL"].set_value(0)
    objekt["I_SLITH_END_SL"].set_value(387)
    objekt["I_SLITH_BEGIN_SL"].set_value(344)
    objekt["I_SEC_IN_PIX_SB"].set_value(24)
    objekt["I_TARGET_X_SL"].set_value(364)
    objekt["I_TARGET_Y_SL"].set_value(300)
    objekt["I_ALLOWED_OFFSET_SB"].set_value(6)

  def settings_menu(self):
    menu = gtk.Menu()

    settings = [ "for Proxitronic (old camera)", "for Wat120N (new camera)" ]

    for item in settings:
      polozka_MI = gtk.MenuItem(item)
      group = polozka_MI
      menu.add(polozka_MI)
      polozka_MI.show()

    return menu

  def settings_apply_BT_clicked(self, widget):
     settings_index = objekt["settings_OM"].get_history()

     if (settings_index == 0):
       self.apply_settings_for_proxitronic()
     elif (settings_index == 1):
       self.apply_settings_for_watec()

  def calibration_BT_clicked(self, widget):
    sm.write_int(pix["I_CALIBRATION"], 1) 

  def change_input_file_BT_clicked(self, widget):
    self.xml_input_FS = gtk.glade.XML("%s/opso.glade" % (cesta["share"]), "input_FS")
    self.xml_input_FS.signal_autoconnect(self)
    self.input_FS = self.xml_input_FS.get_widget("input_FS")

    while (True):
      result = self.input_FS.run()

      if (result == gtk.RESPONSE_OK):
        #nazev_adresare = os.path.dirname(self.input_FS.get_filename())
        #nazev_souboru = os.path.basename(self.input_FS.get_filename())
        nazev_souboru = self.input_FS.get_filename()

        if ((os.path.isdir(nazev_souboru) == False) and (os.access(nazev_souboru, os.R_OK) == True)):
          sm.write_str(pix["S_SOUBOR_IN"], self.input_FS.get_filename())
          objekt["input_file_RB"].set_sensitive(True)
          objekt["input_file_RB"].set_active(True)
        else:
          objekt["input_file_RB"].set_sensitive(False)
          objekt["I_INPUT_RB"].set_active(True)
      else:
        break
      
    self.input_FS.destroy()

  def set_target(self, widget):
    objekt["I_TARGET_X_SL"].set_value(target[objekt["target_OM"].get_history()]["x"])
    objekt["I_TARGET_Y_SL"].set_value(target[objekt["target_OM"].get_history()]["y"])

  def kontrola_count_faulty_pix(self):
    if (self.count_faulty_pix >= FAULTY_PIX_MAX):
      objekt["add_faulty_pix_BT"].set_sensitive(False)
    else:
      objekt["add_faulty_pix_BT"].set_sensitive(True)

  def add_faulty_pix(self, widget):
    self.kontrola_count_faulty_pix()
    
    if (self.count_faulty_pix < FAULTY_PIX_MAX):
      sm.write_array(pix["P_POLE_FAULTY_PIX"], self.count_faulty_pix, 0, int(objekt["I_FAULTY_PIX_X_SL"].get_value()))
      sm.write_array(pix["P_POLE_FAULTY_PIX"], self.count_faulty_pix, 1, int(objekt["I_FAULTY_PIX_Y_SL"].get_value()))
      sm.write_array(pix["P_POLE_FAULTY_PIX"], self.count_faulty_pix, 2, int(objekt["I_FAULTY_PIX_SIZE_SL"].get_value()))
      self.count_faulty_pix += 1
      
      os.system("echo %i:%i:%i >> %s" % (objekt["I_FAULTY_PIX_X_SL"].get_value(),
                                         objekt["I_FAULTY_PIX_Y_SL"].get_value(),
                                         objekt["I_FAULTY_PIX_SIZE_SL"].get_value(),
                                         self.conf_faulty_pix))
      objekt["faulty_pix_OM"].set_menu(self.faulty_pix_menu())
    
  def add_target(self, widget):
    global target, target_popis
    
    target_popis["name"] = objekt["target_ET"].get_text()
    target_popis["x"] = objekt["I_TARGET_X_SL"].get_value()
    target_popis["y"] = objekt["I_TARGET_Y_SL"].get_value()
    target += [ target_popis.copy() ]
    
    os.system("echo %s:%i:%i >> ../../conf/target" % (target_popis["name"], target_popis["x"], target_popis["y"]))
    objekt["target_OM"].set_menu(self.target_menu())
    
  def del_target(self, widget):
    os.system("head -n 2 ../../conf/target > ../../conf/target")
    
    for i in range(len(target)):
      if (target[objekt["target_OM"].get_history()]["name"] != target[i]["name"]):
        os.system("echo %s:%i:%i >> ../../conf/target" % (target[i]["name"], target[i]["x"], target[i]["y"]))
        
    objekt["target_OM"].set_menu(self.target_menu())
    
  def quit(self, window):
    gtk.main_quit()

def main():
  global Okno, target, target_popis, faulty_pix, faulty_pix_popis

  x = 0
  y = 0

  try:
    opts, args = getopt.getopt(sys.argv[1:],
                               "hx:y:",
                               [ "help", "version" ])
  except getopt.GetoptError:
    napoveda()
    sys.exit(1)

  for o, a in opts:
    if o in ("-h", "--help"):
      napoveda()
      sys.exit()
    elif o in ("--version"):
      version()
      sys.exit()
    elif o in ("-x"):
      x = int(a)
    elif o in ("-y"):
      y = int(a)

  syslog.openlog("opso", syslog.LOG_PID|syslog.LOG_CONS, syslog.LOG_LOCAL0)
  if (not os.path.isfile("../../run/opso.pid")):
    syslog.syslog(syslog.LOG_ERR, "Nebezi opso")
    sys.exit()
  else:
    syslog.syslog(syslog.LOG_INFO, "RUN ovladani")

  try:
    soubor = open("../../conf/target", 'r')
    for radek in soubor.readlines():
      pole = radek.split(":")      
      if (len(pole) == 3):
        target_popis["name"] = pole[0]
        try:
          target_popis["x"] = int(pole[1])
          target_popis["y"] = int(pole[2])
        except ValueError, chyba:
          syslog.syslog(syslog.LOG_INFO, "../../conf/target (%s)" % (str(chyba)))
          continue
        target += [ target_popis.copy() ]
    soubor.close()
  except IOError:
    syslog.syslog(syslog.LOG_INFO, "../../conf/target (neexistuje)")

  #signal.signal(signal.SIGUSR1, automation_pointing_off)
  os.system("echo %s > ../../run/ovladani.pid" % (os.getpid()))
  okno = Okno(x, y)
  
if __name__ == '__main__':
  main()
