
/**
  * Author: Jan Fuchs
  * $Date: 2009-04-02 14:10:26 +0200 (Thu, 02 Apr 2009) $
  * $Rev: 8 $
 */

#include <stdlib.h>
#include <stdio.h>
#include <termios.h>
#include <syslog.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>

#include "tty.h"

int tty[TTY_POCET];
struct termios nastaveni_old[TTY_POCET];
struct termios nastaveni[TTY_POCET];

void tty_open(
    void);
void tty_close(
    void);
void tty_write(
    int port,
    int akce,
    int cislo);

void
tty_open(
    void)
{
    int i;
    unsigned char port[11];

    for (i = 0; i < TTY_POCET; ++i) {
        //sprintf (port, "/dev/ttyS%i", i);
        sprintf(port, "/dev/kostkaS%i", i);

        tty[i] = open(port, O_RDWR | O_NOCTTY | O_NONBLOCK);
        if (!tty[i]) {
            syslog(LOG_ERR, "EE Nepodailo se otevt port %s.\n", port);
            exit(1);
        }

        tcgetattr(tty[i], &nastaveni_old[i]);

        nastaveni[i] = nastaveni_old[i];

        cfsetispeed(&nastaveni[i], B4800);
        cfsetospeed(&nastaveni[i], B4800);

        nastaveni[i].c_iflag &=
            ~(IGNBRK | BRKINT | PARMRK | ISTRIP | INLCR | IGNCR | ICRNL |
              IXON);
        nastaveni[i].c_oflag &= ~OPOST;
        nastaveni[i].c_lflag &= ~(ECHO | ECHONL | ICANON | ISIG | IEXTEN);
        nastaveni[i].c_cflag &= ~(CSIZE | PARENB);
        nastaveni[i].c_cflag |= CS8;

        tcflush(tty[i], TCIOFLUSH);
        if (tcsetattr(tty[i], TCSANOW, &nastaveni[i]) != 0) {
            syslog(LOG_ERR, "EE Nepodailo se nastavit parametry portu %s.\n",
                   port);
            close(tty[i]);
            exit(1);
        }

        tty_write(i, 0, 100000);
    }
}

void
tty_close(
    void)
{
    int i;

    for (i = 0; i < TTY_POCET; ++i) {
        tcsetattr(tty[i], TCSANOW, &nastaveni_old[i]);
        close(tty[i]);
    }
}

void
tty_write(
    int port,
    int akce,
    int cislo)
{
    unsigned char jmeno[17];
    unsigned char prikaz[12];
    FILE *soubor;

    if (akce == 0) {
        sprintf(prikaz, "s%06i\r", cislo);
    }
    else if (akce == 1) {
        sprintf(prikaz, "t%06i\r g", cislo);
        sprintf(jmeno, "../conf/kostka_%i", port);
        if ((soubor = fopen(jmeno, "w")) == NULL) {
            syslog(LOG_ERR, "EE fopen\n");
            exit(1);
        }

        fprintf(soubor, "%i", cislo);

        if (fclose(soubor) == EOF) {
            syslog(LOG_ERR, "EE fclose\n");
            exit(1);
        }
    }
    else if (akce == 2) {
        strcpy(prikaz, "D\r");
    }
    else {
        strcpy(prikaz, "E\r");
    }

    syslog(LOG_INFO, "Send '%s' on /dev/kostkaS%i", prikaz, port);
    write(tty[port], prikaz, strlen(prikaz));
}
